// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: reservemodule/reservemodule.proto

package openfmb.reservemodule;

/**
 * <pre>
 * MISSING DOCUMENTATION!!!
 * </pre>
 *
 * Protobuf type {@code reservemodule.ReserveAvailability}
 */
public final class ReserveAvailability extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:reservemodule.ReserveAvailability)
    ReserveAvailabilityOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ReserveAvailability.newBuilder() to construct.
  private ReserveAvailability(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ReserveAvailability() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ReserveAvailability();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_ReserveAvailability_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_ReserveAvailability_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.reservemodule.ReserveAvailability.class, openfmb.reservemodule.ReserveAvailability.Builder.class);
  }

  public static final int INCREMENTALMARGIN_FIELD_NUMBER = 1;
  private openfmb.reservemodule.ReserveMargin incrementalMargin_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
   * @return Whether the incrementalMargin field is set.
   */
  @java.lang.Override
  public boolean hasIncrementalMargin() {
    return incrementalMargin_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
   * @return The incrementalMargin.
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveMargin getIncrementalMargin() {
    return incrementalMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : incrementalMargin_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveMarginOrBuilder getIncrementalMarginOrBuilder() {
    return incrementalMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : incrementalMargin_;
  }

  public static final int MARGIN_FIELD_NUMBER = 2;
  private openfmb.reservemodule.ReserveMargin margin_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin margin = 2;</code>
   * @return Whether the margin field is set.
   */
  @java.lang.Override
  public boolean hasMargin() {
    return margin_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin margin = 2;</code>
   * @return The margin.
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveMargin getMargin() {
    return margin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : margin_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin margin = 2;</code>
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveMarginOrBuilder getMarginOrBuilder() {
    return margin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : margin_;
  }

  public static final int STANDBYMARGIN_FIELD_NUMBER = 3;
  private openfmb.reservemodule.ReserveMargin standbyMargin_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
   * @return Whether the standbyMargin field is set.
   */
  @java.lang.Override
  public boolean hasStandbyMargin() {
    return standbyMargin_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
   * @return The standbyMargin.
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveMargin getStandbyMargin() {
    return standbyMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : standbyMargin_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveMarginOrBuilder getStandbyMarginOrBuilder() {
    return standbyMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : standbyMargin_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (incrementalMargin_ != null) {
      output.writeMessage(1, getIncrementalMargin());
    }
    if (margin_ != null) {
      output.writeMessage(2, getMargin());
    }
    if (standbyMargin_ != null) {
      output.writeMessage(3, getStandbyMargin());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (incrementalMargin_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getIncrementalMargin());
    }
    if (margin_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getMargin());
    }
    if (standbyMargin_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getStandbyMargin());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.reservemodule.ReserveAvailability)) {
      return super.equals(obj);
    }
    openfmb.reservemodule.ReserveAvailability other = (openfmb.reservemodule.ReserveAvailability) obj;

    if (hasIncrementalMargin() != other.hasIncrementalMargin()) return false;
    if (hasIncrementalMargin()) {
      if (!getIncrementalMargin()
          .equals(other.getIncrementalMargin())) return false;
    }
    if (hasMargin() != other.hasMargin()) return false;
    if (hasMargin()) {
      if (!getMargin()
          .equals(other.getMargin())) return false;
    }
    if (hasStandbyMargin() != other.hasStandbyMargin()) return false;
    if (hasStandbyMargin()) {
      if (!getStandbyMargin()
          .equals(other.getStandbyMargin())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasIncrementalMargin()) {
      hash = (37 * hash) + INCREMENTALMARGIN_FIELD_NUMBER;
      hash = (53 * hash) + getIncrementalMargin().hashCode();
    }
    if (hasMargin()) {
      hash = (37 * hash) + MARGIN_FIELD_NUMBER;
      hash = (53 * hash) + getMargin().hashCode();
    }
    if (hasStandbyMargin()) {
      hash = (37 * hash) + STANDBYMARGIN_FIELD_NUMBER;
      hash = (53 * hash) + getStandbyMargin().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.reservemodule.ReserveAvailability parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reservemodule.ReserveAvailability parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reservemodule.ReserveAvailability parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reservemodule.ReserveAvailability parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reservemodule.ReserveAvailability parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reservemodule.ReserveAvailability parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reservemodule.ReserveAvailability parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.reservemodule.ReserveAvailability parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.reservemodule.ReserveAvailability parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.reservemodule.ReserveAvailability parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.reservemodule.ReserveAvailability parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.reservemodule.ReserveAvailability parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.reservemodule.ReserveAvailability prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * Protobuf type {@code reservemodule.ReserveAvailability}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:reservemodule.ReserveAvailability)
      openfmb.reservemodule.ReserveAvailabilityOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_ReserveAvailability_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_ReserveAvailability_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.reservemodule.ReserveAvailability.class, openfmb.reservemodule.ReserveAvailability.Builder.class);
    }

    // Construct using openfmb.reservemodule.ReserveAvailability.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      incrementalMargin_ = null;
      if (incrementalMarginBuilder_ != null) {
        incrementalMarginBuilder_.dispose();
        incrementalMarginBuilder_ = null;
      }
      margin_ = null;
      if (marginBuilder_ != null) {
        marginBuilder_.dispose();
        marginBuilder_ = null;
      }
      standbyMargin_ = null;
      if (standbyMarginBuilder_ != null) {
        standbyMarginBuilder_.dispose();
        standbyMarginBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_ReserveAvailability_descriptor;
    }

    @java.lang.Override
    public openfmb.reservemodule.ReserveAvailability getDefaultInstanceForType() {
      return openfmb.reservemodule.ReserveAvailability.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.reservemodule.ReserveAvailability build() {
      openfmb.reservemodule.ReserveAvailability result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.reservemodule.ReserveAvailability buildPartial() {
      openfmb.reservemodule.ReserveAvailability result = new openfmb.reservemodule.ReserveAvailability(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.reservemodule.ReserveAvailability result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.incrementalMargin_ = incrementalMarginBuilder_ == null
            ? incrementalMargin_
            : incrementalMarginBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.margin_ = marginBuilder_ == null
            ? margin_
            : marginBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.standbyMargin_ = standbyMarginBuilder_ == null
            ? standbyMargin_
            : standbyMarginBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.reservemodule.ReserveAvailability) {
        return mergeFrom((openfmb.reservemodule.ReserveAvailability)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.reservemodule.ReserveAvailability other) {
      if (other == openfmb.reservemodule.ReserveAvailability.getDefaultInstance()) return this;
      if (other.hasIncrementalMargin()) {
        mergeIncrementalMargin(other.getIncrementalMargin());
      }
      if (other.hasMargin()) {
        mergeMargin(other.getMargin());
      }
      if (other.hasStandbyMargin()) {
        mergeStandbyMargin(other.getStandbyMargin());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getIncrementalMarginFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getMarginFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getStandbyMarginFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.reservemodule.ReserveMargin incrementalMargin_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder> incrementalMarginBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
     * @return Whether the incrementalMargin field is set.
     */
    public boolean hasIncrementalMargin() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
     * @return The incrementalMargin.
     */
    public openfmb.reservemodule.ReserveMargin getIncrementalMargin() {
      if (incrementalMarginBuilder_ == null) {
        return incrementalMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : incrementalMargin_;
      } else {
        return incrementalMarginBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
     */
    public Builder setIncrementalMargin(openfmb.reservemodule.ReserveMargin value) {
      if (incrementalMarginBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        incrementalMargin_ = value;
      } else {
        incrementalMarginBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
     */
    public Builder setIncrementalMargin(
        openfmb.reservemodule.ReserveMargin.Builder builderForValue) {
      if (incrementalMarginBuilder_ == null) {
        incrementalMargin_ = builderForValue.build();
      } else {
        incrementalMarginBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
     */
    public Builder mergeIncrementalMargin(openfmb.reservemodule.ReserveMargin value) {
      if (incrementalMarginBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          incrementalMargin_ != null &&
          incrementalMargin_ != openfmb.reservemodule.ReserveMargin.getDefaultInstance()) {
          getIncrementalMarginBuilder().mergeFrom(value);
        } else {
          incrementalMargin_ = value;
        }
      } else {
        incrementalMarginBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
     */
    public Builder clearIncrementalMargin() {
      bitField0_ = (bitField0_ & ~0x00000001);
      incrementalMargin_ = null;
      if (incrementalMarginBuilder_ != null) {
        incrementalMarginBuilder_.dispose();
        incrementalMarginBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
     */
    public openfmb.reservemodule.ReserveMargin.Builder getIncrementalMarginBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getIncrementalMarginFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
     */
    public openfmb.reservemodule.ReserveMarginOrBuilder getIncrementalMarginOrBuilder() {
      if (incrementalMarginBuilder_ != null) {
        return incrementalMarginBuilder_.getMessageOrBuilder();
      } else {
        return incrementalMargin_ == null ?
            openfmb.reservemodule.ReserveMargin.getDefaultInstance() : incrementalMargin_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin incrementalMargin = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder> 
        getIncrementalMarginFieldBuilder() {
      if (incrementalMarginBuilder_ == null) {
        incrementalMarginBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder>(
                getIncrementalMargin(),
                getParentForChildren(),
                isClean());
        incrementalMargin_ = null;
      }
      return incrementalMarginBuilder_;
    }

    private openfmb.reservemodule.ReserveMargin margin_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder> marginBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin margin = 2;</code>
     * @return Whether the margin field is set.
     */
    public boolean hasMargin() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin margin = 2;</code>
     * @return The margin.
     */
    public openfmb.reservemodule.ReserveMargin getMargin() {
      if (marginBuilder_ == null) {
        return margin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : margin_;
      } else {
        return marginBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin margin = 2;</code>
     */
    public Builder setMargin(openfmb.reservemodule.ReserveMargin value) {
      if (marginBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        margin_ = value;
      } else {
        marginBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin margin = 2;</code>
     */
    public Builder setMargin(
        openfmb.reservemodule.ReserveMargin.Builder builderForValue) {
      if (marginBuilder_ == null) {
        margin_ = builderForValue.build();
      } else {
        marginBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin margin = 2;</code>
     */
    public Builder mergeMargin(openfmb.reservemodule.ReserveMargin value) {
      if (marginBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          margin_ != null &&
          margin_ != openfmb.reservemodule.ReserveMargin.getDefaultInstance()) {
          getMarginBuilder().mergeFrom(value);
        } else {
          margin_ = value;
        }
      } else {
        marginBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin margin = 2;</code>
     */
    public Builder clearMargin() {
      bitField0_ = (bitField0_ & ~0x00000002);
      margin_ = null;
      if (marginBuilder_ != null) {
        marginBuilder_.dispose();
        marginBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin margin = 2;</code>
     */
    public openfmb.reservemodule.ReserveMargin.Builder getMarginBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getMarginFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin margin = 2;</code>
     */
    public openfmb.reservemodule.ReserveMarginOrBuilder getMarginOrBuilder() {
      if (marginBuilder_ != null) {
        return marginBuilder_.getMessageOrBuilder();
      } else {
        return margin_ == null ?
            openfmb.reservemodule.ReserveMargin.getDefaultInstance() : margin_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin margin = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder> 
        getMarginFieldBuilder() {
      if (marginBuilder_ == null) {
        marginBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder>(
                getMargin(),
                getParentForChildren(),
                isClean());
        margin_ = null;
      }
      return marginBuilder_;
    }

    private openfmb.reservemodule.ReserveMargin standbyMargin_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder> standbyMarginBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
     * @return Whether the standbyMargin field is set.
     */
    public boolean hasStandbyMargin() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
     * @return The standbyMargin.
     */
    public openfmb.reservemodule.ReserveMargin getStandbyMargin() {
      if (standbyMarginBuilder_ == null) {
        return standbyMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : standbyMargin_;
      } else {
        return standbyMarginBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
     */
    public Builder setStandbyMargin(openfmb.reservemodule.ReserveMargin value) {
      if (standbyMarginBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        standbyMargin_ = value;
      } else {
        standbyMarginBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
     */
    public Builder setStandbyMargin(
        openfmb.reservemodule.ReserveMargin.Builder builderForValue) {
      if (standbyMarginBuilder_ == null) {
        standbyMargin_ = builderForValue.build();
      } else {
        standbyMarginBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
     */
    public Builder mergeStandbyMargin(openfmb.reservemodule.ReserveMargin value) {
      if (standbyMarginBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          standbyMargin_ != null &&
          standbyMargin_ != openfmb.reservemodule.ReserveMargin.getDefaultInstance()) {
          getStandbyMarginBuilder().mergeFrom(value);
        } else {
          standbyMargin_ = value;
        }
      } else {
        standbyMarginBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
     */
    public Builder clearStandbyMargin() {
      bitField0_ = (bitField0_ & ~0x00000004);
      standbyMargin_ = null;
      if (standbyMarginBuilder_ != null) {
        standbyMarginBuilder_.dispose();
        standbyMarginBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
     */
    public openfmb.reservemodule.ReserveMargin.Builder getStandbyMarginBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getStandbyMarginFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
     */
    public openfmb.reservemodule.ReserveMarginOrBuilder getStandbyMarginOrBuilder() {
      if (standbyMarginBuilder_ != null) {
        return standbyMarginBuilder_.getMessageOrBuilder();
      } else {
        return standbyMargin_ == null ?
            openfmb.reservemodule.ReserveMargin.getDefaultInstance() : standbyMargin_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin standbyMargin = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder> 
        getStandbyMarginFieldBuilder() {
      if (standbyMarginBuilder_ == null) {
        standbyMarginBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder>(
                getStandbyMargin(),
                getParentForChildren(),
                isClean());
        standbyMargin_ = null;
      }
      return standbyMarginBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:reservemodule.ReserveAvailability)
  }

  // @@protoc_insertion_point(class_scope:reservemodule.ReserveAvailability)
  private static final openfmb.reservemodule.ReserveAvailability DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.reservemodule.ReserveAvailability();
  }

  public static openfmb.reservemodule.ReserveAvailability getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ReserveAvailability>
      PARSER = new com.google.protobuf.AbstractParser<ReserveAvailability>() {
    @java.lang.Override
    public ReserveAvailability parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ReserveAvailability> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ReserveAvailability> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.reservemodule.ReserveAvailability getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

